import cherrypy
import command

class robotServer:
	def __init__(self):
		pass

	robot = command.robot()

	@cherrypy.expose
	def log_keydown(self, key=0, **kwargs):
		print "%s key down" % key
		#TODO adjust GPIO
		if key == '38': #up arrow
			self.robot.commands['forward'] = 1
		if key == '37': #left arrow
			self.robot.commands['left'] = 1
		if key == '39': #right arrow
			self.robot.commands['right'] = 1
		if key == '40': #down arrow
			self.robot.commands['reverse'] = 1
		if key == '16': #shift
			self.robot.commands['speed'] = 1
		self.robot.set_drive()
		self.robot.set_pins()

	@cherrypy.expose
	def log_keyup(self, key=0, **kwargs):
		print "%s key up" % key
		#TODO adjust GPIO
		if key == '38': #up arrow
			self.robot.commands['forward'] = 0
		if key == '37': #left arrow
			self.robot.commands['left'] = 0
		if key == '39': #right arrow
			self.robot.commands['right'] = 0
		if key == '40': #down arrow
			self.robot.commands['reverse'] = 0
		if key == '16': #shift
			self.robot.commands['speed'] = .5
		self.robot.set_drive()
		self.robot.set_pins()

	@cherrypy.expose
	def index(self, **kwargs):
		return '''
<html>
<head>
	<title> Robot Server</title>
	<script type="text/javascript" src="http://code.jquery.com/jquery-1.10.0.min.js"></script>
</head>
<body>
	<div>
		Robot Control On
	</div>

	<script type="text/javascript">
	$( document ).ready(function() {	
		$(document).keydown(function(event) {
			console.log("keydown " + event.keyCode);
			$.ajax({
				url:"log_keydown",
				data: {
					key:event.keyCode
				}
			});
		});
	});
	$( document ).ready(function() {
		$(document).keyup(function(event) {
			console.log("keyup " + event.keyCode);
			$.ajax({
				url:"log_keyup",
				data: {
					key:event.keyCode
				}
			});
		});
	});
	</script>
</body>
</html>
'''

if __name__ == '__main__':
	#cherrypy.config.update({'server.socket_host': '127.0.0.1', 'server.socket_port': 8080})
	#cherrypy.config.update({'server.socket_host': '192.168.2.7', 'server.socket_port': 80,})
	cherrypy.config.update({'server.socket_host': '10.0.1.33', 'server.socket_port': 80})
	cherrypy.quickstart(robotServer())
