#!/usr/bin/python

from robot import robotServer
from cherrypy.process.plugins import Daemonizer
import cherrypy

import socket
import fcntl
import struct

def get_ip_address(ifname):
	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	return socket.inet_ntoa(fcntl.ioctl(s.fileno(), 0x8915, struct.pack('256s', ifname[:15]))[20:24])

Daemonizer(cherrypy.engine, stderr='/root/Desktop/error.log', stdout='/root/Desktop/access.log').subscribe()

ipaddress = get_ip_address('wlan0')
if not ipaddress: ipaddress = get_ip_address('eth0')
if not ipaddress: ipaddress = "192.168.1.134"

cherrypy.tree.mount(robotServer(), "")
cherrypy.config.update({
	'server.socket_host': ipaddress,
	'server.socket_port': 80
})
cherrypy.engine.start()
cherrypy.engine.block()
